package	jp.co.sds_corp.jdbrowser;

import java.awt.Frame;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

import jp.co.sds_corp.jdbrowser.status.JvmStatusPanel;
import jp.co.sds_corp.util.common.CmnManifest;
import jp.co.sds_corp.util.common.CmnProperty;
import jp.co.sds_corp.util.window.WindowUtility;

/**
* バージョン情報を表示します。
*/
public class AboutDialog extends JDialog
{
	private static final long serialVersionUID = 1L;
	Window		parent;
	SetupParam	param;
	CmnProperty	prop;
	JLabel		LBL_VER;
	JButton		BTN_OK;
	JOptionPane pane;
	JDialog		paneDlg;
	JvmStatusPanel		jvm;
	String		errTitle;
	String		errMsg;

	public AboutDialog( Window parent, SetupParam param ) {
		super( (Frame )parent, true );
		this.parent = parent;
		this.param = param;
		prop = new CmnProperty( "resource.jdbrowser" );
		errTitle = prop.getString( "browser.err.title" );
		errMsg = prop.getString( "browser.err.message" );

		createControls();
	}

	protected void createControls() {
		setSize( 300, 250 );
		WindowUtility.setHideOnEscape( this );
		String title = prop.getString( "about.title" );
		setTitle( title );

		Box panel = new Box( BoxLayout.Y_AXIS );
		title = "";
		String version = "";
		try {
			CmnManifest mn = new CmnManifest( getClass() );
			title = mn.getTitle();
			version = mn.getVersion();
		} catch ( Exception ex ) {
			ex.printStackTrace();
		}
		String html = title + " ver. " + version + "<BR>"
		    + "<BR>"
			+ "Copyright (C) 1995-2007 S.D.S. all rights reserved.<BR>"
			+ "<A HREF='http://www.sds-corp.co.jp/'>http://www.sds-corp.co.jp/</A><BR>"
			+ "<BR><HR color='gray'>";
		LBL_VER = new JLabel( "<html>" + html + "</html>" );
		panel.add( LBL_VER );
		jvm = new JvmStatusPanel( parent, param );
		try {
			jvm.refresh();
		} catch ( Exception ex ) {
		}
		panel.add( jvm.getMemoryPanel() );
		// jvm.setAddHtml( html );
		// JScrollPane sp = new JScrollPane( jvm,
		//	JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
		//	JScrollPane.HORIZONTAL_SCROLLBAR_NEVER );
		//panel.add( sp );

		BTN_OK = new JButton( "Ok" );
		BTN_OK.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				setVisible( false );
			}
		} );
		// getRootPane().setDefaultButton( BTN_OK );
		// panel.add( BTN_OK );
		getContentPane().add( panel );

		pane = new JOptionPane( panel,
				JOptionPane.INFORMATION_MESSAGE, JOptionPane.DEFAULT_OPTION );
		paneDlg = pane.createDialog( parent, title );
		// setContentPane( pane );
	}

	public void setVisible( boolean var ) {
		if ( var == true ) {
			try {
				refresh();
			} catch ( Exception ex ) {
ex.printStackTrace();
				JOptionPane.showMessageDialog( this,
					errMsg + "\n" + ex, errTitle,
					JOptionPane.ERROR_MESSAGE );
			}
			WindowUtility.center( parent, paneDlg );
			paneDlg.setVisible( true );
		}
		// super.setVisible( var );
	}

	public void refresh() throws Exception {
		jvm.refresh();
		WindowUtility.center( parent, this );
	}

}
