package	jp.co.sds_corp.jdbrowser.demo;

import java.net.URL;
import java.util.Iterator;

import javax.swing.JOptionPane;
import javax.swing.UIManager;

import jp.co.sds_corp.jdbrowser.JDBrowser;
import jp.co.sds_corp.jdbrowser.connect.ConnectInfo;
import jp.co.sds_corp.util.config.DOMConfiguration;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.db.DbAccess;
import jp.co.sds_corp.util.db.DbInfo;
import jp.co.sds_corp.util.log.CmnLogger;

public class JDBrowserDemo
{
	static CmnLogger logger = CmnLogger.getInstance();
	ConnectInfo con;
	DbAccess	db;

	protected void startHsql( IConfiguration config ) throws Exception {
		IConfiguration dbc = null;
		IConfiguration cons = config.getChild( "Connection" );
		Iterator<IConfiguration> itr = cons.getChilds( "db" );
		while ( itr.hasNext()) {
			dbc = (IConfiguration )itr.next();
			if ( dbc.getAttributes().get( "name" ).equals( "hsql" )) {
				break;
			}
		}
		if ( dbc == null ) {
			throw( new Exception( "db config [hsql] not found" ));
		}
		con = new ConnectInfo( dbc );
		DbInfo info = new DbInfo( con.getDriver(), con.getUrl(),
			con.getUser(), con.getPassword(), con.getEncode() );
		db = new DbAccess( info );
	}

	protected void createTable() throws Exception {
		try {
			db.connect( con.getProperties() );
			String sql;
			sql = "create table TABLE_TEST ("
					+ "col1 numeric(9,3),"
					+ "col2 char(12)"
				+ ")";
			db.execute( sql );
			sql = "insert into TABLE_TEST values (1.0,'AAA')";
			db.execute( sql );
			sql = "insert into TABLE_TEST values (1.4,'A222')";
			db.execute( sql );
			sql = "insert into TABLE_TEST values (2.3,'B222')";
			db.execute( sql );
			sql = "create view VIEW_TEST as select * from TABLE_TEST";
			db.execute( sql );
			db.commit();
		} finally {
			try {
				db.disconnect();
			} catch ( Exception ex ) {
			}
		}
	}

	public static void main( String[] args ) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception exc) {
			System.err.println( "Error loading L&F: " + exc);
		}
		try {
			String file = null;
			try {
				file = System.getProperty( "JDBrowser.config" );
			} catch ( Exception fex ) {
			}
System.out.println( "config=" + file );
			DOMConfiguration config = new DOMConfiguration( new URL( file ));

			JDBrowserDemo demo = new JDBrowserDemo();
			demo.startHsql( config );
			demo.createTable();

			JDBrowser win = new JDBrowser();
			win.init( config );
			win.setVisible( true );
			win.startBrowser();
			win.toFront();
		} catch ( Throwable ex ) {
			logger.error( ex, "initialize error", ex );
			JOptionPane.showMessageDialog( null,
			"Error occurred.\n" + ex,
			"Error",
			JOptionPane.ERROR_MESSAGE );
			System.exit( 9 );
		}
	}
}
