package	jp.co.sds_corp.jdbrowser.event;

import java.util.EventObject;

public class TableEvent extends EventObject
{
	private static final long serialVersionUID = 1L;
	/**
	* 指定したオブジェクトによって初期化された TableEvent オブジェクトを構築します。
	*/
	public TableEvent( Object source ) {
		super( source );
	}

	/**
	* 指定したオブジェクトによって初期化された TableEvent オブジェクトを構築します。
	*/
	public TableEvent( Object source, String table )
	{
		super( source );
		this.table = table;
	}

	public TableEvent( Object source,
		String catalog, String schema, String table )
	{
		super( source );
		this.catalog = catalog;
		this.schema = schema;
		this.table = table;
	}

	String	catalog;	// catalog
	String	schema;	// schema
	String	table;	// table

	/**
	* catalogを設定します。
	* @param	var		設定するデータ
	*/
	public void setCatalog( String var ) {
		this.catalog = var;
	}
	/**
	* catalogを取得します。
	* @return	catalog
	*/
	public String getCatalog() {
		return catalog;
	}

	/**
	* schemaを設定します。
	* @param	var		設定するデータ
	*/
	public void setSchema( String var ) {
		this.schema = var;
	}
	/**
	* schemaを取得します。
	* @return	schema
	*/
	public String getSchema() {
		return schema;
	}

	/**
	* tableを設定します。
	* @param	var		設定するデータ
	*/
	public void setTable( String var ) {
		this.table = var;
	}
	/**
	* tableを取得します。
	* @return	table
	*/
	public String getTable() {
		return table;
	}


}
