package	jp.co.sds_corp.jdbrowser.generator;

import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.util.Vector;

import jp.co.sds_corp.jdbrowser.ColumnInfo;
import jp.co.sds_corp.jdbrowser.SetupParam;
import jp.co.sds_corp.jdbrowser.connect.ConnectInfo;
import jp.co.sds_corp.util.common.CmnProperty;
import jp.co.sds_corp.util.db.DbAccess;

public abstract class AbstractGenerator
{
	SetupParam	param;
	CmnProperty	prop;
	DbAccess	db;
	String util_pkg = null;
	String pkg = null;
	ConnectInfo	con;
	String	catalog;
	String	schema;
	String	table;
	Vector<ColumnInfo>	vecClm = new Vector<ColumnInfo>();
	Vector<String>	vecKey = new Vector<String>();

	public AbstractGenerator( SetupParam param )
		throws Exception
	{
		prop = new CmnProperty( "resource.jdbrowser" );
		this.param = param;
	}

	public void select( DbAccess db,
			ConnectInfo con, String catalog, String schema, String table )
		throws Exception
	{
		this.db = db;
		this.con = con;
		this.catalog = catalog;
		this.schema = schema;
		this.table = table;

		selectKey( db, con, catalog, schema, table );
		DatabaseMetaData meta = db.getConnection().getMetaData();
		ResultSet rset = meta.getColumns( catalog, schema, table, null );
		for ( ;; ) {
			if ( !rset.next()) {
				break;
			}
			ColumnInfo info = new ColumnInfo( rset );
			if ( vecKey.indexOf( info.getName() ) >= 0 ) {
				info.setKey( true );
			}
			vecClm.add( info );
		}
	}

	public void selectKey( DbAccess db,
			ConnectInfo con, String catalog, String schema, String table )
		throws Exception
	{
		vecKey.clear();
		DatabaseMetaData meta = db.getConnection().getMetaData();
		ResultSet rset = meta.getPrimaryKeys( catalog, schema, table );
		for ( ;; ) {
			if ( !rset.next()) {
				break;
			}
			vecKey.add( rset.getString( "COLUMN_NAME" ));
		}
	}

	protected int countKey() {
		int     nKey = 0;
		for ( int i = 0; i < vecClm.size(); i++ ) {
			ColumnInfo col = (ColumnInfo )vecClm.get( i );
			if ( !col.isKey()) {
				continue;
			}
			nKey++;
		}
		return nKey;
	}

}
