package	jp.co.sds_corp.jdbrowser.generator;

import jp.co.sds_corp.util.common.CmnString;
import jp.co.sds_corp.util.config.IConfiguration;

public class CsvParam
{
	IConfiguration config;

	public CsvParam( IConfiguration config ) throws Exception {
		if ( config == null ) {
			return;
		}
		this.config = config;
		String var;
		var = config.getAttributes().get( "columnSeparator", "\t" );
		columnSeparator = CmnString.unescape( var );
		var = config.getAttributes().get( "rowSeparator", "\n" );
		rowSeparator = CmnString.unescape( var );
		encode = config.getAttributes().get( "encode", null );
	}
	public IConfiguration getConfiguration() throws Exception {
		return config;
	}

	/**
	* 設定情報を保存します。
	* @param	config	設定情報
	*/
	public void saveConfig( IConfiguration config ) throws Exception {
		config.setAttribute( "columnSeparator", CmnString.escape( columnSeparator ));
		config.setAttribute( "rowSeparator", CmnString.escape( rowSeparator ));
		if ( encode != null && encode.length() > 0 ) {
			config.setAttribute( "encode", encode );
		}
	}

	String	columnSeparator;	// columnSeparator
	String	rowSeparator;	// rowSeparator
	String	encode;	// encode

	/**
	* columnSeparatorを設定します。
	* @param	var		設定するデータ
	*/
	public void setColumnSeparator( String var ) {
		this.columnSeparator = var;
	}
	/**
	* columnSeparatorを取得します。
	* @return	columnSeparator
	*/
	public String getColumnSeparator() {
		return columnSeparator;
	}

	/**
	* rowSeparatorを設定します。
	* @param	var		設定するデータ
	*/
	public void setRowSeparator( String var ) {
		this.rowSeparator = var;
	}
	/**
	* rowSeparatorを取得します。
	* @return	rowSeparator
	*/
	public String getRowSeparator() {
		return rowSeparator;
	}

	/**
	* encodeを設定します。
	* @param	var		設定するデータ
	*/
	public void setEncode( String var ) {
		this.encode = var;
	}
	/**
	* encodeを取得します。
	* @return	encode
	*/
	public String getEncode() {
		return encode;
	}

}
