package	jp.co.sds_corp.jdbrowser.generator;

import java.util.Iterator;

import jp.co.sds_corp.util.config.IConfiguration;

public class DocParam
{
	IConfiguration config;

	public DocParam( IConfiguration config ) throws Exception {
		if ( config == null) {
			return;
		}
		this.config = config;
		generatorClass = config.getAttributes().get( "generator", null );
	}
	public IConfiguration getConfiguration() throws Exception {
		return config;
	}

	/**
	* 設定情報を保存します。
	* @param	config	設定情報
	*/
	public void saveConfig( IConfiguration config ) throws Exception {
		IConfiguration attr = this.config.getAttributes();
		config.setAttribute( "type", attr.get( "type" ));
		config.setAttribute( "template", attr.get( "template" ));
		config.setAttribute( "sheet", attr.get( "sheet" ));
		if ( generatorClass != null && generatorClass.length() > 0 ) {
			config.setAttribute( "generator", generatorClass );
		}
		Iterator<IConfiguration> itr = this.config.getChilds();
		while ( itr.hasNext()) {
			IConfiguration c = (IConfiguration )itr.next();
			config.addChild( c );
		}
	}

	String	generatorClass;	// generatorClass

	/**
	* generatorClassを設定します。
	* @param	var		設定するデータ
	*/
	public void setGeneratorClass( String var ) {
		this.generatorClass = var;
	}
	/**
	* generatorClassを取得します。
	* @return	generatorClass
	*/
	public String getGeneratorClass() {
		return generatorClass;
	}

}
