package	jp.co.sds_corp.jdbrowser.generator;

import jp.co.sds_corp.jdbrowser.SetupParam;

public class GeneratorFactory
{
	public static IGenerator createJavaGenerator( SetupParam param )
		throws Exception
	{
		JavaParam jprm = param.getJavaParam();
		IGenerator ret;
		if ( jprm.getGeneratorClass() == null ) {
			ret = new JavaGenerator( param );
		} else {
			Class cls = Class.forName( jprm.getGeneratorClass() );
			ret = (IGenerator )cls.newInstance();
		}
		return ret;
	}

	public static IGenerator createDocumentGenerator( SetupParam param )
		throws Exception
	{
		DocParam dprm = param.getDocParam();
		IGenerator ret;
		if ( dprm.getGeneratorClass() == null ) {
			ret = new DocumentGenerator( param );
		} else {
			Class cls = Class.forName( dprm.getGeneratorClass() );
			ret = (IGenerator )cls.newInstance();
		}
		return ret;
	}

}
