package	jp.co.sds_corp.jdbrowser.generator;

import java.util.Iterator;
import java.util.Vector;

import jp.co.sds_corp.util.config.IConfiguration;

public class JavaParam
{
	IConfiguration config;

	public JavaParam( IConfiguration config ) throws Exception {
		if ( config == null ) {
			return;
		}
		this.config = config;
		IConfiguration attr = config.getAttributes();
		pkg = attr.get( "package" );
		utilPackage = attr.get( "util_package" );
		encode = attr.get( "encode", null );
		generatorClass = attr.get( "generator", null );
		Iterator<IConfiguration> itr = config.getChilds( "audit_column" );
		while ( itr.hasNext()) {
			IConfiguration aa = ((IConfiguration )itr.next()).getAttributes();
			String clm = aa.get( "column" );
			auditColumn.add( clm );
		}
	}
	public IConfiguration getConfiguration() throws Exception {
		return config;
	}

	/**
	* 設定情報を保存します。
	* @param	config	設定情報
	*/
	public void saveConfig( IConfiguration config ) throws Exception {
		if ( generatorClass != null && generatorClass.length() > 0 ) {
			config.setAttribute( "generator", generatorClass );
		}
		config.setAttribute( "package", pkg );
		config.setAttribute( "util_package", utilPackage );
		if ( encode != null && encode.length() > 0 ) {
			config.setAttribute( "encode", encode );
		}
		for ( int i = 0; i < auditColumn.size(); i++ ) {
			String col = (String )auditColumn.get( i );
			IConfiguration c = config.addChild( "audit_column" );
			c.setAttribute( "column", col );
		}
	}

	String	generatorClass;	// generatorClass
	String	pkg;	// pkg
	String	utilPackage;	// utilPackage
	String	encode;	// encode
	Vector<String>	auditColumn = new Vector<String>();	// auditColumn

	/**
	* generatorClassを設定します。
	* @param	var		設定するデータ
	*/
	public void setGeneratorClass( String var ) {
		this.generatorClass = var;
	}
	/**
	* generatorClassを取得します。
	* @return	generatorClass
	*/
	public String getGeneratorClass() {
		return generatorClass;
	}

	/**
	* pkgを設定します。
	* @param	var		設定するデータ
	*/
	public void setPackage( String var ) {
		this.pkg = var;
	}
	/**
	* pkgを取得します。
	* @return	pkg
	*/
	public String getPackage() {
		return pkg;
	}

	/**
	* vecAuditを設定します。
	* @param	var		設定するデータ
	*/
	public void setAuditColumn( Vector<String> var ) {
		this.auditColumn = var;
	}
	/**
	* vecAuditを取得します。
	* @return	vecAudit
	*/
	public Vector<String> listAuditColumn() {
		return auditColumn;
	}

	/**
	* utilPackageを設定します。
	* @param	var		設定するデータ
	*/
	public void setUtilPackage( String var ) {
		this.utilPackage = var;
	}
	/**
	* utilPackageを取得します。
	* @return	utilPackage
	*/
	public String getUtilPackage() {
		return utilPackage;
	}

	/**
	* encodeを設定します。
	* @param	var		設定するデータ
	*/
	public void setEncode( String var ) {
		this.encode = var;
	}
	/**
	* encodeを取得します。
	* @return	encode
	*/
	public String getEncode() {
		return encode;
	}

}
