package	jp.co.sds_corp.jdbrowser.procedure;

import java.awt.Dimension;
import java.awt.Window;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

import jp.co.sds_corp.jdbrowser.SetupParam;
import jp.co.sds_corp.jdbrowser.connect.ConnectInfo;
import jp.co.sds_corp.jdbrowser.util.BrowserUtil;
import jp.co.sds_corp.util.common.CmnProperty;
import jp.co.sds_corp.util.db.DbAccess;

/**
* procedureの情報を表示します。
*/
public class ProcedureDesign extends JInternalFrame
{
	private static final long serialVersionUID = 1L;
	Window		parent;
	SetupParam	param;
	CmnProperty	prop;
	DbAccess	db;
	ConnectInfo	con;
	String		catalog;
	String		schema;
	String		proc;
	ProcedureDesignSheet	sheet;
	ProcedureDesignSheet.Model	model;
	JTextField	TXT_SCH = new JTextField();
	JTextField	TXT_CAT = new JTextField();
	JTextField	TXT_TBL = new JTextField();

	public ProcedureDesign( Window parent, SetupParam param ) {
		super( "", true, true, true, true );
		this.parent = parent;
		this.param = param;
		prop = new CmnProperty( "resource.jdbrowser" );
		createControls();
	}

	protected void createControls() {
		setSize( 650, 300 );

		Box panel1 = new Box( BoxLayout.Y_AXIS );
		Box panel2 = new Box( BoxLayout.X_AXIS );
		panel2.setMaximumSize( new Dimension( 1000, 10 ));
		panel2.add( new JLabel( "Catalog:" ));
		TXT_CAT.setEditable( false );
		panel2.add( TXT_CAT );
		panel2.add( new JLabel( "Schema:" ));
		TXT_SCH.setEditable( false );
		panel2.add( TXT_SCH );
		panel2.add( new JLabel( "Procedure:" ));
		TXT_TBL.setEditable( false );
		panel2.add( TXT_TBL );
		panel1.add( panel2 );

		sheet = new ProcedureDesignSheet();
		model = (ProcedureDesignSheet.Model )sheet.getModel();
		JScrollPane sp = new JScrollPane( sheet );
		panel1.add( sp );
		getContentPane().add( panel1 );
	}

	public void select( DbAccess db,
			ConnectInfo con, String catalog, String schema, String proc )
		throws Exception
	{
		this.con = con;
		this.catalog = catalog;
		this.schema = schema;
		this.proc = proc;
		DatabaseMetaData meta = db.getConnection().getMetaData();
		ResultSet rset = meta.getProcedureColumns( catalog, schema, proc, null );
		for ( ;; ) {
			if ( !rset.next()) {
				break;
			}
			model.addRow( rset );
		}

		TXT_CAT.setText( catalog );
		TXT_SCH.setText( schema );
		TXT_TBL.setText( proc );

		String title = prop.getString( "procedure.title" );
		String name = BrowserUtil.getName( catalog, schema, proc );
		setTitle( title + " - " + " " + con.getDisplayName() + " " + name );
	}

}
