package	jp.co.sds_corp.jdbrowser.procedure;

import java.awt.Component;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;

import javax.swing.JCheckBox;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;

import jp.co.sds_corp.jdbrowser.ColumnInfo;
import jp.co.sds_corp.util.common.CmnProperty;

/**
* procedureの定義情報を表示します。
*/
public class ProcedureDesignSheet extends JTable
{
	private static final long serialVersionUID = 1L;
	CmnProperty	prop;
	Model model;

	public ProcedureDesignSheet() {
		prop = new CmnProperty( "resource.jdbrowser" );
		model = new Model();
		String text;
		text = prop.getString( "procedure.column1.text" );
		model.addColumn( text );
		text = prop.getString( "procedure.column2.text" );
		model.addColumn( text );
		text = prop.getString( "procedure.column3.text" );
		model.addColumn( text );
		text = prop.getString( "procedure.column4.text" );
		model.addColumn( text );
		text = prop.getString( "procedure.column5.text" );
		model.addColumn( text );
		text = prop.getString( "procedure.column6.text" );
		model.addColumn( text );
		text = prop.getString( "procedure.column7.text" );
		model.addColumn( text );
		setModel( model ); 

		setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
		setAutoResizeMode( JTable.AUTO_RESIZE_LAST_COLUMN );
		int[] widths = { 100, 100, 30, 30, 30, 50, 250 };
		TableColumn col;
		for ( int nLoop = 0; nLoop < widths.length; nLoop++ ) {
			col = getColumnModel().getColumn( nLoop );
			col.setPreferredWidth( widths[nLoop] );
		}
		col = getColumnModel().getColumn( 4 );
		NoNullsRenderer renderer = new NoNullsRenderer();
		col.setCellRenderer( renderer );
	}

	public static class Model extends DefaultTableModel
	{
		private static final long serialVersionUID = 1L;

		public void addRow( ResultSet rset ) throws Exception {
			Object[] arr = new Object[7];
			arr[0] = rset.getString( "COLUMN_NAME" );
			arr[1] = rset.getString( "TYPE_NAME" );
			if ( ColumnInfo.needPrecision( (String )arr[1] )) {
				arr[2] = rset.getString( "LENGTH" );
				if ( ColumnInfo.needScale( (String )arr[1] )) {
					arr[3] = rset.getString( "PRECISION" );
				}
			}
			arr[4] = Boolean.valueOf( rset.getInt( "NULLABLE" ) == 0 );
			int nType = rset.getInt( "COLUMN_TYPE" );
			switch ( nType ) {
			case DatabaseMetaData.procedureColumnUnknown:
				arr[5] = "(Unknown)"; break;
			case DatabaseMetaData.procedureColumnIn:
				arr[5] = "I"; break;
			case DatabaseMetaData.procedureColumnInOut:
				arr[5] = "I/O"; break;
			case DatabaseMetaData.procedureColumnOut:
				arr[5] = "O"; break;
			case DatabaseMetaData.procedureColumnReturn:
				arr[5] = "(Return)"; break;
			case DatabaseMetaData.procedureColumnResult:
				arr[5] = "(Result)"; break;
			}
			arr[6] = rset.getString( "REMARKS" );
			addRow( arr );
		}
		public boolean isCellEditable( int row, int col ) {
			return false;
		}
	}

	public class NoNullsRenderer extends JCheckBox implements TableCellRenderer
	{
		public Component getTableCellRendererComponent( JTable table,
			Object value, boolean isSelected, boolean hasFocus,
			int row, int column )
		{
			setSelected( value != null && ((Boolean )value).booleanValue());
			if ( isSelected ) {
				setBackground( ProcedureDesignSheet.this.getSelectionBackground() );
			} else {
				setBackground( ProcedureDesignSheet.this.getBackground() );
			}
			return this;
		}
	}
}
