package	jp.co.sds_corp.jdbrowser.setup;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SpringLayout;

import jp.co.sds_corp.jdbrowser.SetupParam;
import jp.co.sds_corp.jdbrowser.generator.CsvParam;
import jp.co.sds_corp.util.common.CmnProperty;
import jp.co.sds_corp.util.common.CmnString;

public class CsvSetupPanel extends JPanel
{
	private static final long serialVersionUID = 1L;
	SetupParam	param;
	CsvParam	cprm;
	CmnProperty	prop;
	JTextField	TXT_COL = new JTextField( 10 );
	JTextField	TXT_ROW = new JTextField( 10 );
	JTextField	TXT_ENCODE = new JTextField( 10 );

	CsvSetupPanel( SetupParam param ) {
		this.param = param;
		this.cprm = param.getCsvParam();
		prop = new CmnProperty( "resource.jdbrowser" );

		JLabel lbl;
		// setLayout( new BoxLayout( this, BoxLayout.Y_AXIS ));
		SpringLayout layout = new SpringLayout();
		setLayout( layout );

		lbl = new JLabel( "Column separator:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
			5, SpringLayout.WEST, this );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			5, SpringLayout.NORTH, this );
		add( lbl );
		layout.putConstraint( SpringLayout.WEST, TXT_COL,
			5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, TXT_COL,
			0, SpringLayout.NORTH, lbl );
		add( TXT_COL );

		lbl = new JLabel( "Row separator:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
			5, SpringLayout.WEST, this );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			5, SpringLayout.SOUTH, TXT_COL );
		add( lbl );
		layout.putConstraint( SpringLayout.WEST, TXT_ROW,
			0, SpringLayout.WEST, TXT_COL );
		layout.putConstraint( SpringLayout.NORTH, TXT_ROW,
			0, SpringLayout.NORTH, lbl );
		add( TXT_ROW );

		lbl = new JLabel( "Encode:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
			5, SpringLayout.WEST, this );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			5, SpringLayout.SOUTH, TXT_ROW );
		add( lbl );
		layout.putConstraint( SpringLayout.WEST, TXT_ENCODE,
			0, SpringLayout.WEST, TXT_ROW );
		layout.putConstraint( SpringLayout.NORTH, TXT_ENCODE,
			0, SpringLayout.NORTH, lbl );
		add( TXT_ENCODE );
	}

	protected void setup() {
		TXT_COL.setText( CmnString.escape( cprm.getColumnSeparator() ));
		TXT_ROW.setText( CmnString.escape( cprm.getRowSeparator() ));
		TXT_ENCODE.setText( cprm.getEncode() );
	}

	protected boolean check() {
		return true;
	}
	protected void update() {
		cprm.setColumnSeparator( CmnString.unescape( TXT_COL.getText() ));
		cprm.setRowSeparator( CmnString.unescape( TXT_ROW.getText() ));
		String text = TXT_ENCODE.getText();
		if ( text != null && text.length() > 0 ) {
			cprm.setEncode( text );
		}
	}

}
