package	jp.co.sds_corp.jdbrowser.setup;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SpringLayout;

import jp.co.sds_corp.jdbrowser.SetupParam;
import jp.co.sds_corp.jdbrowser.generator.DocParam;
import jp.co.sds_corp.util.common.CmnProperty;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.config.UnspecifiedPropertyException;

public class DocSetupPanel extends JPanel
{
	private static final long serialVersionUID = 1L;
	SetupParam	param;
	DocParam	dprm;
	CmnProperty	prop;
	JScrollPane	sp;
	String[]	types = { "Excel" };
	JComboBox	CMB_TYPE = new JComboBox( types );
	JTextField	TXT_TEMP = new JTextField( 30 );
	JTextField	TXT_SHEET = new JTextField( 30 );
	JTextArea	TXT_SCR = new JTextArea( 10, 50 );

	DocSetupPanel( SetupParam param ) {
		this.param = param;
		this.dprm = param.getDocParam();
		prop = new CmnProperty( "resource.jdbrowser" );

		JLabel lbl;
		// setLayout( new BoxLayout( this, BoxLayout.Y_AXIS ));
		SpringLayout layout = new SpringLayout();
		setLayout( layout );

		lbl = new JLabel( "Type:    " );
		layout.putConstraint( SpringLayout.WEST, lbl,
			5, SpringLayout.WEST, this );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			5, SpringLayout.NORTH, this );
		add( lbl );
		layout.putConstraint( SpringLayout.WEST, CMB_TYPE,
			5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, CMB_TYPE,
			0, SpringLayout.NORTH, lbl );
		add( CMB_TYPE );

		lbl = new JLabel( "Template:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
			5, SpringLayout.WEST, this );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			5, SpringLayout.SOUTH, CMB_TYPE );
		add( lbl );
		layout.putConstraint( SpringLayout.WEST, TXT_TEMP,
			0, SpringLayout.WEST, CMB_TYPE );
		layout.putConstraint( SpringLayout.NORTH, TXT_TEMP,
			0, SpringLayout.NORTH, lbl );
		add( TXT_TEMP );

		lbl = new JLabel( "Sheet:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
			5, SpringLayout.WEST, this );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			5, SpringLayout.SOUTH, TXT_TEMP );
		add( lbl );
		layout.putConstraint( SpringLayout.WEST, TXT_SHEET,
			0, SpringLayout.WEST, TXT_TEMP );
		layout.putConstraint( SpringLayout.NORTH, TXT_SHEET,
			0, SpringLayout.NORTH, lbl );
		add( TXT_SHEET );

		lbl = new JLabel( "Script:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
			5, SpringLayout.WEST, this );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			5, SpringLayout.SOUTH, TXT_SHEET );
		add( lbl );
		sp = new JScrollPane( TXT_SCR );
		layout.putConstraint( SpringLayout.WEST, sp,
			0, SpringLayout.WEST, TXT_SHEET );
		layout.putConstraint( SpringLayout.NORTH, sp,
			0, SpringLayout.NORTH, lbl );
		add( sp );
	}

	protected void setup() {
		try {
			IConfiguration config = dprm.getConfiguration();
			IConfiguration attr = config.getAttributes();
			CMB_TYPE.setSelectedItem( attr.get( "type" ));
			TXT_TEMP.setText( attr.get( "template" ));
			TXT_SHEET.setText( attr.get( "sheet" ));
			IConfiguration c = config.getChild( "Script" );
			if ( c != null ) {
				try {
					TXT_SCR.setText( c.get() );
				} catch ( UnspecifiedPropertyException uex ) {
				}
			}
			TXT_SCR.setCaretPosition( 0 );
		} catch ( Exception ex ) {
ex.printStackTrace();
		}
	}

	protected boolean check() {
		return true;
	}
	protected void update() {
		try {
			IConfiguration config = dprm.getConfiguration();
			config.setAttribute( "type", (String )CMB_TYPE.getSelectedItem() );
			config.setAttribute( "template", TXT_TEMP.getText() );
			config.setAttribute( "sheet", TXT_SHEET.getText() );
			IConfiguration c = config.getChild( "Script" );
			if ( c == null ) {
				c = config.addChild( "Script" );
			}
			c.setAttribute( "type", "JavaScript" );
			c.set( TXT_SCR.getText() );
		} catch ( Exception ex ) {
ex.printStackTrace();
		}

	}
}
