package	jp.co.sds_corp.jdbrowser.setup;

import java.awt.Frame;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JTabbedPane;

import jp.co.sds_corp.jdbrowser.SetupParam;
import jp.co.sds_corp.util.common.CmnProperty;
import jp.co.sds_corp.util.window.WindowUtility;

/**
* バージョン情報を表示します。
*/
public class SetupDialog extends JDialog
{
	private static final long serialVersionUID = 1L;
	Window		parent;
	SetupParam	param;
	CmnProperty	prop;
	SetupPanel		pnlSetup;
	CsvSetupPanel	pnlCsv;
	JavaSetupPanel	pnlJava;
	DocSetupPanel	pnlDoc;
	JButton		BTN_OK;
	JButton		BTN_APPLY;
	JButton		BTN_CANCEL;
	int			nRes = -1;
	Vector<ActionListener>	vecLsn = new Vector<ActionListener>();

	public SetupDialog( Window parent, SetupParam param ) {
		super( (Frame )parent, true );
		this.parent = parent;
		this.param = param;
		prop = new CmnProperty( "resource.jdbrowser" );

		createControls();
		setup();
	}

	protected void createControls() {
		setResizable( true );
		setSize( 400, 400 );
		String title = prop.getString( "setup.title" );
		setTitle( title );
		WindowUtility.setHideOnEscape( this );

		Box box1 = new Box( BoxLayout.Y_AXIS );
		JTabbedPane tp = new JTabbedPane();
		String text;
		text = prop.getString( "setup.tab1.text" );
		pnlSetup = new SetupPanel( param );
		tp.addTab( text, pnlSetup );
		text = prop.getString( "setup.tab2.text" );
		pnlCsv = new CsvSetupPanel( param );
		tp.addTab( text, pnlCsv );
		text = prop.getString( "setup.tab3.text" );
		pnlJava = new JavaSetupPanel( param );
		tp.addTab( text, pnlJava );
		text = prop.getString( "setup.tab4.text" );
		pnlDoc = new DocSetupPanel( param );
		tp.addTab( text, pnlDoc );
		box1.add( tp );

		Box box2 = new Box( BoxLayout.X_AXIS );
		text = prop.getString( "setup.button1.text" );
		BTN_OK = new JButton( text );
		BTN_OK.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				onOk();
			}
		} );
		getRootPane().setDefaultButton( BTN_OK );
		box2.add( BTN_OK );
		text = prop.getString( "setup.button2.text" );
		BTN_APPLY = new JButton( text );
		BTN_APPLY.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				onApply();
			}
		} );
		box2.add( BTN_APPLY );
		text = prop.getString( "setup.button3.text" );
		BTN_CANCEL = new JButton( text );
		BTN_CANCEL.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				onCancel();
			}
		} );
		box2.add( BTN_CANCEL );
		box1.add( box2 );
		getContentPane().add( box1 );
	}

	protected SetupPanel createSetupPanel() {
		SetupPanel pnl = new SetupPanel( param );
		return pnl;
	}

	protected void onOk() {
		nRes = 0;
		onApply();
		setVisible( false );
	}

	protected void onApply() {
		if ( !pnlSetup.check()) {
			return;
		}
		if ( !pnlCsv.check()) {
			return;
		}
		if ( !pnlJava.check()) {
			return;
		}
		if ( !pnlDoc.check()) {
			return;
		}
		pnlSetup.update();
		pnlCsv.update();
		pnlJava.update();
		pnlDoc.update();
		fireActionPerformed( "Apply" );
	}

	protected void onCancel() {
		nRes = 1;
		setVisible( false );
	}

	public int getResult() {
		return nRes;
	}

	public void addActionListener( ActionListener lsn ) {
		vecLsn.add( lsn );
	}
	public void removeActionListener( ActionListener lsn ) {
		vecLsn.remove( lsn );
	}
	public void fireActionPerformed( String cmd ) {
		ActionEvent ev = new ActionEvent( this, ActionEvent.ACTION_PERFORMED, cmd );
		for ( int i = 0; i < vecLsn.size(); i++ ) {
			ActionListener lsn = (ActionListener )vecLsn.get( i );
			lsn.actionPerformed( ev );
		}
	}

	public void setVisible( boolean var ) {
		if ( var ) {
			nRes = -1;
			setup();
		}
		super.setVisible( var );
	}

	protected void setup() {
		pnlSetup.setup();
		pnlCsv.setup();
		pnlJava.setup();
		pnlDoc.setup();
	}

}
