package	jp.co.sds_corp.jdbrowser.setup;

import java.awt.Rectangle;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.SpringLayout;

import jp.co.sds_corp.jdbrowser.SetupParam;
import jp.co.sds_corp.util.common.CmnProperty;
import jp.co.sds_corp.util.window.FontChooser;

public class SetupPanel extends JPanel
{
	private static final long serialVersionUID = 1L;
	SetupParam	param;
	CmnProperty	prop;
	JTextField	TXT_X = new JTextField( 4 );
	JTextField	TXT_Y = new JTextField( 4 );
	JTextField	TXT_WIDTH = new JTextField( 4 );
	JTextField	TXT_HEIGHT = new JTextField( 4 );
	JTextField	TXT_ROWSET = new JTextField( 40 );
	JCheckBox	CHK_DEBUG;
	FontChooser	pnlFont;

	SetupPanel( SetupParam param ) {
		this.param = param;
		prop = new CmnProperty( "resource.jdbrowser" );

		JLabel lbl;
		// setLayout( new BoxLayout( this, BoxLayout.Y_AXIS ));
		SpringLayout layout = new SpringLayout();
		setLayout( layout );

		lbl = new JLabel( "Position:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
			5, SpringLayout.WEST, this );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			5, SpringLayout.NORTH, this );
		add( lbl );
		layout.putConstraint( SpringLayout.WEST, TXT_X,
			5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, TXT_X,
			0, SpringLayout.NORTH, lbl );
		add( TXT_X );
		lbl = new JLabel( "x" );
		layout.putConstraint( SpringLayout.WEST, lbl,
			5, SpringLayout.EAST, TXT_X );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			0, SpringLayout.NORTH, TXT_X );
		add( lbl );
		layout.putConstraint( SpringLayout.WEST, TXT_Y,
			5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, TXT_Y,
			0, SpringLayout.NORTH, lbl );
		add( TXT_Y );

		lbl = new JLabel( "Size:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
			10, SpringLayout.EAST, TXT_Y );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			0, SpringLayout.NORTH, TXT_X );
		add( lbl );
		layout.putConstraint( SpringLayout.WEST, TXT_WIDTH,
			5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, TXT_WIDTH,
			0, SpringLayout.NORTH, lbl );
		add( TXT_WIDTH );
		lbl = new JLabel( "x" );
		layout.putConstraint( SpringLayout.WEST, lbl,
			5, SpringLayout.EAST, TXT_WIDTH );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			0, SpringLayout.NORTH, TXT_WIDTH );
		add( lbl );
		layout.putConstraint( SpringLayout.WEST, TXT_HEIGHT,
			5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, TXT_HEIGHT,
			0, SpringLayout.NORTH, lbl );
		add( TXT_HEIGHT );

		lbl = new JLabel( "RowSet:" );
		layout.putConstraint( SpringLayout.WEST, lbl,
			5, SpringLayout.WEST, this );
		layout.putConstraint( SpringLayout.NORTH, lbl,
			5, SpringLayout.SOUTH, TXT_WIDTH );
		add( lbl );
		layout.putConstraint( SpringLayout.WEST, TXT_ROWSET,
			5, SpringLayout.EAST, lbl );
		layout.putConstraint( SpringLayout.NORTH, TXT_ROWSET,
			0, SpringLayout.NORTH, lbl );
		add( TXT_ROWSET );

		CHK_DEBUG = new JCheckBox( "debug" );
		layout.putConstraint( SpringLayout.WEST, CHK_DEBUG,
			5, SpringLayout.WEST, this );
		layout.putConstraint( SpringLayout.NORTH, CHK_DEBUG,
			5, SpringLayout.SOUTH, TXT_ROWSET );
		add( CHK_DEBUG );

		pnlFont = new FontChooser();
		layout.putConstraint( SpringLayout.WEST, pnlFont,
			5, SpringLayout.WEST, this );
		layout.putConstraint( SpringLayout.NORTH, pnlFont,
			5, SpringLayout.SOUTH, CHK_DEBUG );
		add( pnlFont );
	}

	protected void setup() {
		Rectangle rect = param.getBounds();
		int i;
		i = (int )rect.getX();
		TXT_X.setText( String.valueOf( i ));
		i = (int )rect.getY();
		TXT_Y.setText( String.valueOf( i ));
		i = (int )rect.getWidth();
		TXT_WIDTH.setText( String.valueOf( i ));
		i = (int )rect.getHeight();
		TXT_HEIGHT.setText( String.valueOf( i ));
		TXT_ROWSET.setText( param.getRowSet() );
		if ( param.isDebug()) {
			CHK_DEBUG.setSelected( true );
		} else {
			CHK_DEBUG.setSelected( false );
		}
		pnlFont.setSelectedFont( param.getFont() );
	}

	protected boolean check() {
		try {
			getInteger( TXT_X, "X" );
			getInteger( TXT_Y, "Y" );
			getInteger( TXT_WIDTH, "Width" );
			getInteger( TXT_HEIGHT, "Height" );
		} catch ( Exception ex ) {
			return false;
		}
		return true;
	}
	protected void update() {
		param.setFont( pnlFont.getSelectedFont() );
		try {
			int x = getInteger( TXT_X, "X" );
			int y = getInteger( TXT_Y, "Y" );
			int w = getInteger( TXT_WIDTH, "Width" );
			int h = getInteger( TXT_HEIGHT, "Height" );
			param.setBounds( new Rectangle( x, y, w, h ));
		} catch ( Exception ex ) {
		}
		param.setRowSet( TXT_ROWSET.getText() );
		if ( CHK_DEBUG.isSelected()) {
			param.setDebug( true );
		} else {
			param.setDebug( false );
		}
	}

	protected int getInteger( JTextField txt, String name ) throws Exception {
		int ret = 0;
		try {
			ret = Integer.valueOf( txt.getText() ).intValue();
		} catch ( Exception ex ) {
			String title = prop.getString( "setup.err1.title" );
			String msg = prop.getString( "setup.err1.message" );
			JOptionPane.showMessageDialog( this,
				"[" + name + "] " + msg + "\n" + ex, title,
				JOptionPane.ERROR_MESSAGE );
			throw( ex );
		}
		return ret;
	}

}
