package	jp.co.sds_corp.jdbrowser.status;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import jp.co.sds_corp.jdbrowser.SetupParam;
import jp.co.sds_corp.util.common.CmnProperty;
import jp.co.sds_corp.util.window.WindowUtility;

/**
* バージョン情報を表示します。
*/
public class PropertyDialog extends JDialog
{
	private static final long serialVersionUID = 1L;
	Window		parent;
	SetupParam	param;
	CmnProperty	prop;
	JTextField	TXT_KEY = new JTextField();
	JTextArea	TXT_VAL = new JTextArea( 5, 30 );


	public PropertyDialog( Window parent, SetupParam param ) {
		super( (Frame )parent, true );
		this.parent = parent;
		this.param = param;
		prop = new CmnProperty( "resource.jdbrowser" );

		createControls();
	}

	protected void createControls() {
		setResizable( true );
		setSize( 450, 210 );
		WindowUtility.setHideOnEscape( this );

		JPanel pnl = new JPanel();

		pnl.setLayout( new BoxLayout( pnl, BoxLayout.Y_AXIS ));
		Box box1 = new Box( BoxLayout.X_AXIS );
		JLabel lbl1 = new JLabel( "Key:  " );
		box1.add( lbl1 );
		TXT_KEY.setMaximumSize( new Dimension( 1000, 24 ));
		TXT_KEY.setEditable( false );
		box1.add( TXT_KEY );
		pnl.add( box1 );

		Box box2 = new Box( BoxLayout.X_AXIS );
		JLabel lbl2 = new JLabel( "Value:" );
		box2.add( lbl2 );
		TXT_VAL.setEditable( false );
		JScrollPane sp = new JScrollPane( TXT_VAL );
		TXT_VAL.setLineWrap( true );
		box2.add( sp );
		pnl.add( box2 );

		String title = prop.getString( "status.property.title" );
		JButton BTN_OK = new JButton( "Ok" );
		BTN_OK.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				PropertyDialog.this.setVisible( false );
			}
		} );
		getRootPane().setDefaultButton( BTN_OK );
		Box box3 = new Box( BoxLayout.X_AXIS );
		box3.add( BTN_OK );
		pnl.add( box3 );
		getContentPane().add( pnl );
	}

	public void setValue( String key, String value ) {
		TXT_KEY.setText( key );
		TXT_VAL.setText( value );
	}

}
