package	jp.co.sds_corp.jdbrowser.table;

import java.awt.Component;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.DefaultCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;

import jp.co.sds_corp.jdbrowser.ColumnInfo;
import jp.co.sds_corp.util.common.CmnProperty;

/**
* table/viewの定義情報を表示します。
*/
public class TableDesignSheet extends JTable
{
	private static final long serialVersionUID = 1L;
	CmnProperty	prop;
	Model model;
	JComboBox	CMB_TYPE;
	JCheckBox	CHK_KEY;
	JCheckBox	CHK_NONULL;
	Vector<? extends Object>	vecType;
	Vector<ColumnInfo>	vecCol = new Vector<ColumnInfo>();
	boolean	editable = true;

	public TableDesignSheet() {
		prop = new CmnProperty( "resource.jdbrowser" );
		model = new Model();
		String text;
		text = prop.getString( "design.column1.text" );
		model.addColumn( text );
		text = prop.getString( "design.column2.text" );
		model.addColumn( text );
		text = prop.getString( "design.column3.text" );
		model.addColumn( text );
		text = prop.getString( "design.column4.text" );
		model.addColumn( text );
		text = prop.getString( "design.column5.text" );
		model.addColumn( text );
		text = prop.getString( "design.column6.text" );
		model.addColumn( text );
		text = prop.getString( "design.column7.text" );
		model.addColumn( text );
		text = prop.getString( "design.column8.text" );
		model.addColumn( text );
		setModel( model ); 

		// setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
		setRowSelectionAllowed( true );
		setColumnSelectionAllowed( true );
		setAutoResizeMode( JTable.AUTO_RESIZE_OFF );
		TableColumn col;
		int[] widths = { 100, 100, 35, 35, 35, 35, 100, 200 };
		for ( int nLoop = 0; nLoop < widths.length; nLoop++ ) {
			col = getColumnModel().getColumn( nLoop );
			col.setPreferredWidth( widths[nLoop] );
		}
		CMB_TYPE = new JComboBox();
		CMB_TYPE.setBorder( BorderFactory.createEmptyBorder() );
		col = getColumnModel().getColumn( 1 );
		col.setCellEditor( new DefaultCellEditor( CMB_TYPE ));
		col = getColumnModel().getColumn( 4 );
		CHK_KEY = new JCheckBox();
		col.setCellEditor( new DefaultCellEditor( CHK_KEY ));
		col.setCellRenderer( new CheckBoxRenderer());
		col = getColumnModel().getColumn( 5 );
		CHK_NONULL = new JCheckBox();
		col.setCellEditor( new DefaultCellEditor( CHK_NONULL ));
		col.setCellRenderer( new CheckBoxRenderer());
	}

	public void setTypeList( Vector<? extends Object> vec ) {
		this.vecType = vec;
		for ( int i = 0; i < vec.size(); i++ ) {
			CMB_TYPE.addItem( vec.get( i ));
		}
	}

	public void setEditable( boolean var ) {
		this.editable = var;
	}

	public boolean isCellEditable( int row, int column ) {
		return this.editable;
	}

	public class Model extends DefaultTableModel	
	{
		private static final long serialVersionUID = 1L;

		public void addRow( ColumnInfo info ) throws Exception {
			vecCol.add( info );
			Object[] arr = new Object[getColumnCount()];
			arr[0] = info.getName();
			arr[1] = info.getType();
			if ( info.needPrecision()) {
				arr[2] = String.valueOf( info.getPrecision());
				if ( info.needScale()) {
					arr[3] = String.valueOf( info.getScale());
				}
			}
			arr[4] = Boolean.valueOf( info.isKey());
			arr[5] = Boolean.valueOf( info.isNullable());
			arr[6] = info.getDefValue();
			arr[7] = info.getRemarks();
			addRow( arr );
		}

		public boolean isCellEditable( int row, int col ) {
			String type = (String )getValueAt( row, 1 );
			switch ( col ) {
			case 2: return ColumnInfo.needPrecision( type );
			case 3: return ColumnInfo.needScale( type );
			}
			return true;
		}
		public void clearRow() {
			setRowCount( 0 );
			vecCol.clear();
		}
		public void addRow() {
			ColumnInfo info = new ColumnInfo();
			vecCol.add( info );
			addRow( new Vector() );
		}
		public void insertRow( int row ) {
			ColumnInfo info = new ColumnInfo();
			vecCol.add( row, info );
			insertRow( row, new Vector() );
		}
		public void delRow( int row ) {
			vecCol.remove( row );
			removeRow( row );
		}
		public ColumnInfo getRow( int row ) {
			ColumnInfo info = (ColumnInfo )vecCol.get( row );
			return info;
		}

	}

	public class CheckBoxRenderer extends JCheckBox implements TableCellRenderer
	{
		private static final long serialVersionUID = 1L;

		public Component getTableCellRendererComponent( JTable table,
			Object value, boolean isSelected, boolean hasFocus,
			int row, int column )
		{
			setSelected( value != null && ((Boolean )value).booleanValue());
			if ( isSelected ) {
				setBackground( table.getSelectionBackground() );
			} else {
				setBackground( table.getBackground() );
			}
			return this;
		}
	}

}
