package	jp.co.sds_corp.jdbrowser.table;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.Timestamp;
import java.sql.Types;
import java.util.Vector;

import javax.sql.rowset.CachedRowSet;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.DefaultListSelectionModel;
import javax.swing.JButton;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.ListCellRenderer;
import javax.swing.ListSelectionModel;
import javax.swing.UIManager;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellEditor;

import jp.co.sds_corp.jdbrowser.ColumnInfo;
import jp.co.sds_corp.jdbrowser.FrameManager;
import jp.co.sds_corp.jdbrowser.NodeInfo;
import jp.co.sds_corp.jdbrowser.SetupParam;
import jp.co.sds_corp.jdbrowser.connect.ConnectInfo;
import jp.co.sds_corp.jdbrowser.generator.CsvLoader;
import jp.co.sds_corp.jdbrowser.generator.CsvParam;
import jp.co.sds_corp.jdbrowser.generator.CsvSaver;
import jp.co.sds_corp.jdbrowser.util.BrowserUtil;
import jp.co.sds_corp.util.common.CmnDate;
import jp.co.sds_corp.util.common.CmnProperty;
import jp.co.sds_corp.util.db.DbAccess;
import jp.co.sds_corp.util.db.DbInfo;
import jp.co.sds_corp.util.db.DbTable;
import jp.co.sds_corp.util.window.WindowUtility;

/**
* tableの情報を表示します。
*/
public class TableViewer extends JInternalFrame
{
	private static final long serialVersionUID = 1L;
	Window		parent;
	SetupParam	param;
	NodeInfo.Type	type = NodeInfo.Type.TABLE;
	CmnProperty	prop;
	DbAccess	db;
	ConnectInfo	con;
	String		catalog;
	String		schema;
	String		table;
	RowHeader	rowHd;
	int			nRow;
	JScrollPane	sp;
	ViewerSheet	sheet;
	ViewerSheet.Model	model;
	JTextField	TXT_SCH = new JTextField();
	JTextField	TXT_CAT = new JTextField();
	JTextField	TXT_TBL = new JTextField();
	JToolBar	toolBar;
	JButton		BTN_REFRESH;
	JButton		BTN_SAVE;
	JButton		BTN_LOAD;
	JButton		BTN_ADD;
	JButton		BTN_DEL;
	JButton		BTN_TRUNC;
	JButton		BTN_DESIGN;
	JTextField	TXT_WHERE = new JTextField();
	String		errTitle;
	String		errMsg;
	String		selFile;
	CachedRowSet	rowset;
	ConnectionWrapper conWrap;
	FrameManager	frmMng;

	public TableViewer( Window parent, SetupParam param, FrameManager frmMng ) {
		super( "", true, true, true, true );
		this.parent = parent;
		this.param = param;
		this.frmMng = frmMng;

		prop = new CmnProperty( "resource.jdbrowser" );
		errTitle = prop.getString( "viewer.err.title" );
		errMsg = prop.getString( "viewer.err.message" );
		createControls();

		addInternalFrameListener( new InternalFrameAdapter() {
			public void internalFrameClosed( InternalFrameEvent ev ) {
				closed();
			}
		});
	}

	protected void createControls() {
		setSize( 650, 300 );

		Box panel1 = new Box( BoxLayout.Y_AXIS );
		Box panel2 = new Box( BoxLayout.X_AXIS );
		panel2.setMaximumSize( new Dimension( 1000, 10 ));
		panel2.add( new JLabel( "Catalog:" ));
		TXT_CAT.setEditable( false );
		panel2.add( TXT_CAT );
		panel2.add( new JLabel( "Schema:" ));
		TXT_SCH.setEditable( false );
		panel2.add( TXT_SCH );
		panel2.add( new JLabel( "Table:" ));
		TXT_TBL.setEditable( false );
		panel2.add( TXT_TBL );
		panel1.add( panel2 );

		JPanel panel3 = new JPanel( new BorderLayout() );
		toolBar = createToolBar();
		panel3.add( toolBar, BorderLayout.NORTH );
		Box panel4 = new Box( BoxLayout.X_AXIS );
		panel4.add( new JLabel( "Where:" ));
		panel4.add( TXT_WHERE );
		panel1.add( panel4 );

		sheet = new ViewerSheet();
		DefaultListSelectionModel selModel = new DefaultListSelectionModel() {
			private static final long serialVersionUID = 1L;

			public void setSelectionInterval( int index0, int index1 ) {
				int org_row = sheet.getSelectedRow();
				if ( org_row >= 0 && org_row != index0 ) {
					if ( sheet.isChanged()) {
						try {
							if ( org_row >= nRow ) {
								insertRow( org_row );
							} else {
								updateRow( org_row );
							}
						} catch ( Exception ex ) {
							error( ex, true );
							return;
						}
					} else if ( org_row >= nRow ) {
						model.removeRow( org_row );
						((DefaultListModel )rowHd.getModel()).remove( org_row );
					}
				}
				super.setSelectionInterval( index0, index1 );
			}
		};
		sheet.setSelectionModel( selModel );
		model = (ViewerSheet.Model )sheet.getModel();

		sp = new JScrollPane( sheet );
		rowHd = new RowHeader( sheet );
//		rowHd.setBackground( sp.getViewport().getBackground() );
		rowHd.setSelectionMode( ListSelectionModel.MULTIPLE_INTERVAL_SELECTION );
/*
		rowHd.addListSelectionListener( new ListSelectionListener() {
			public void valueChanged( ListSelectionEvent ev ) {
				ListSelectionModel sm = sheet.getSelectionModel();
				sm.clearSelection();
				for ( int i = 0; i < rowHd.getModel().getSize(); i++ ) {
					ListSelectionModel hm = rowHd.getSelectionModel();
					if ( hm.isSelectedIndex( i )) {
						sm.addSelectionInterval( i, i );
					}
				}
			}
		} );
*/
		sp.setRowHeaderView( rowHd );
		sp.getRowHeader().setPreferredSize(
			new Dimension( 30, sheet.getPreferredSize().height ));
		sp.setHorizontalScrollBarPolicy( JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS );
		panel3.add( sp, BorderLayout.CENTER );
		panel1.add( panel3 );
		getContentPane().add( panel1 );
	}

	protected JToolBar createToolBar() {
		JToolBar toolBar = new JToolBar( "toolbar" );
		String text;
		BTN_REFRESH = new JButton();
		text = prop.getString( "viewer.refresh.tooltip" );
		BTN_REFRESH.setToolTipText( text );
		WindowUtility.setButtonIcon( this, BTN_REFRESH,
			"/resource/refresh.png", "/resource/refresh_d.png" );
		BTN_REFRESH.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				try {
					select( db, con, catalog, schema, table );
				} catch ( Exception ex ) {
					error( ex, true );
				}
			}
		} );
		toolBar.add( BTN_REFRESH );
		toolBar.addSeparator();

		BTN_ADD = new JButton();
		WindowUtility.setButtonIcon( this, BTN_ADD, "/resource/plus.png" );
		text = prop.getString( "viewer.add.tooltip" );
		BTN_ADD.setToolTipText( text );
		BTN_ADD.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				addRow();
			}
		} );
		toolBar.add( BTN_ADD );
		BTN_DEL = new JButton();
		WindowUtility.setButtonIcon( this, BTN_DEL, "/resource/minus.png" );
		text = prop.getString( "viewer.del.tooltip" );
		BTN_DEL.setToolTipText( text );
		BTN_DEL.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				try {
					deleteRow();
				} catch ( Exception ex ) {
					error( ex, true );
				}
			}
		} );
		toolBar.add( BTN_DEL );
		BTN_TRUNC = new JButton();
		WindowUtility.setButtonIcon( this, BTN_TRUNC, "/resource/cleanup.png" );
		text = prop.getString( "viewer.trunc.tooltip" );
		BTN_TRUNC.setToolTipText( text );
		BTN_TRUNC.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				try {
					truncate();
				} catch ( Exception ex ) {
					error( ex, true );
				}
			}
		} );
		toolBar.add( BTN_TRUNC );
		toolBar.addSeparator();

		BTN_LOAD = new JButton();
		text = prop.getString( "viewer.load.tooltip" );
		BTN_LOAD.setToolTipText( text );
		WindowUtility.setButtonIcon( this, BTN_LOAD, "/resource/open.png" );
		BTN_LOAD.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				try {
					load();
				} catch ( Exception ex ) {
					error( ex, true );
				}
			}
		} );
		toolBar.add( BTN_LOAD );
		BTN_SAVE = new JButton();
		text = prop.getString( "viewer.save.tooltip" );
		BTN_SAVE.setToolTipText( text );
		WindowUtility.setButtonIcon( this, BTN_SAVE, "/resource/save.png" );
		BTN_SAVE.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				try {
					save();
				} catch ( Exception ex ) {
					error( ex, true );
				}
			}
		} );
		toolBar.add( BTN_SAVE );
		toolBar.addSeparator();

		BTN_DESIGN = new JButton();
		text = prop.getString( "viewer.design.tooltip" );
		BTN_DESIGN.setToolTipText( text );
		WindowUtility.setButtonIcon( this, BTN_DESIGN, "/resource/design.png" );
		BTN_DESIGN.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent ev ) {
				try {
					showDesigner();
				} catch ( Exception ex ) {
					error( ex, true );
				}
			}
		} );
		toolBar.add( BTN_DESIGN );
		return toolBar;
	}

	private void error( Exception ex, boolean rollback ) {
		if ( rollback ) {
			try {
				db.rollback();
			} catch ( Exception ex2 ) {
			}
		}
ex.printStackTrace();
		JOptionPane.showMessageDialog( this,
			errMsg + "\n" + ex, errTitle,
			JOptionPane.ERROR_MESSAGE );
	}

	class RowHeader extends JList
	{
		private static final long serialVersionUID = 1L;
		JTableHeader header;

		public RowHeader( JTable table ) {
			super( new DefaultListModel() );
			header = table.getTableHeader();
			setCellRenderer( new RowHeaderRenderer( header ));
			setFixedCellHeight( table.getRowHeight() );
		}
		public Color getBackground() {
			if ( header == null ) {
				return super.getBackground();
			}
			return header.getBackground();
		}
	}
	class RowHeaderRenderer extends JLabel implements ListCellRenderer
	{
		private static final long serialVersionUID = 1L;
		private JTableHeader header;

		public RowHeaderRenderer( JTableHeader header ) {
			this.header = header;
		}
		public Component getListCellRendererComponent( JList list, Object value,
			int index, boolean isSelected, boolean cellHasFocus )
		{
			setOpaque( true );
			setBackground( header.getBackground() );
			setBorder( UIManager.getBorder( "TableHeader.cellBorder" ));
			setHorizontalAlignment( RIGHT );
			setFont( header.getFont() );
			setText(( value == null ) ? "" : value.toString());
			return this;
		}
	}

	private CachedRowSet createCachedRowSet() throws Exception {
		String cls = con.getRowSet();
		if ( cls == null ) {
			cls = param.getRowSet();
		}
		if ( cls == null ) {
			cls = "com.sun.rowset.CachedRowSetImpl";
		}
		CachedRowSet ret = (CachedRowSet )Class.forName( cls ).newInstance();
		return ret;
	}

	public void select( DbAccess db,
			ConnectInfo con, String catalog, String schema, String table )
		throws Exception
	{
		this.db = db;
		this.con = con;
		this.catalog = catalog;
		this.schema = schema;
		this.table = table;

		Vector<String> vecKey = listKeys( db, catalog, schema, table );

		sheet.setInit( false );
		model.setRowCount( 0 );
		((DefaultListModel )rowHd.getModel()).clear();
		DbTable tbl = new DbTable();
		String sql = "SELECT * FROM " + table;
		if ( TXT_WHERE.getText().length() > 0 ) {
			sql += " " + TXT_WHERE.getText();
		}
/*
		db.executeQuery( sql );
		rowset = createCachedRowSet();
		rowset.populate( db.getResultSet() );
		rowset.setTableName( table );
		db.setResultSet( rowset );
*/
/**/
		rowset = createCachedRowSet();
		DbInfo info = db.getDbInfo();
		rowset.setUrl( info.getUrl() );
		rowset.setUsername( info.getUser() );
		rowset.setPassword( info.getPassword() );
		rowset.setTransactionIsolation( Connection.TRANSACTION_READ_COMMITTED );
		rowset.setCommand( sql );
		rowset.setReadOnly( false );
		conWrap = new ConnectionWrapper( db.getConnection(), param.isDebug() );
		rowset.execute( conWrap );
		db.setResultSet( rowset );
/**/

		nRow = 0;
		for ( ;; ) {
			if ( !db.fetch( tbl )) {
				break;
			}
			nRow++;
			sheet.addRow( tbl );
			((DefaultListModel )rowHd.getModel()).addElement( "" + nRow );
		}
		if ( nRow == 0 ) {
			sheet.initColumn( tbl );
		}
		if ( vecKey.size() > 0 ) {
			int[] keys = new int[vecKey.size()];
			for ( int i = 0; i < vecKey.size(); i++ ) {
				String key = (String )vecKey.get( i );
				keys[i] = tbl.getIndex( key ) + 1;
				if ( keys[i] <= 0 ) {
					throw( new Exception( "key[" + key + "] not found." ));
				}
			}
			rowset.setKeyColumns( keys );
		}

		TXT_CAT.setText( catalog );
		TXT_SCH.setText( schema );
		TXT_TBL.setText( table );

		String title = prop.getString( "viewer.title" );
		String name = BrowserUtil.getName( catalog, schema, table );
		setTitle( title + " - " + con.getDisplayName() + " " + name );
	}

	public Vector<String> listKeys( DbAccess db,
			String catalog, String schema, String table )
		throws Exception
	{
		Vector<String> vec = new Vector<String>();
		DatabaseMetaData meta = db.getConnection().getMetaData();
		ResultSet rset = meta.getPrimaryKeys( catalog, schema, table );
		for ( ;; ) {
			if ( !rset.next()) {
				break;
			}
			vec.add( rset.getString( "COLUMN_NAME" ));
		}
		return vec;
	}

	protected void insertRow( int row ) throws Exception {
		rowset.moveToInsertRow();
		int nUpd = updateColumn( row );
		if ( nUpd > 0 ) {
			try {
				rowset.insertRow();
				rowset.moveToCurrentRow();
				rowset.acceptChanges( conWrap );
			} catch ( Exception ex ) {
				throw( ex );
			}
			select( db, con, catalog, schema, table );
		}
	}

	protected void updateRow( int row ) throws Exception {
		rowset.absolute( row + 1 );
		int nUpd = updateColumn( row );
		if ( nUpd > 0 ) {
			rowset.updateRow();
			try {
				rowset.acceptChanges( conWrap );
			} catch ( Exception ex ) {
				conWrap.rollback();
				throw( ex );
			}
			select( db, con, catalog, schema, table );
//			sheet.clearChanged();
		}
	}

	protected int updateColumn( int row ) throws Exception {
		int nUpd = 0;
		stopEditing( row );
		for ( int i = 0; i < model.getColumnCount(); i++ ) {
			if ( !sheet.isColumnChanged( i )) {
				continue;
			}
			nUpd++;
			ColumnInfo clm = sheet.getColumn( i );
			String var = (String )model.getValueAt( row, i );
			if ( var == null || var.length() == 0 ) {
				rowset.updateNull( i+1 );
			} else {
				switch ( clm.getJavaType() ) {
				case Types.DATE:
					rowset.updateDate( i+1, new java.sql.Date(
						new CmnDate( var, "yyyy-MM-dd" ).getTime().getTime() ));
					break;
				case Types.TIMESTAMP:
				case Types.TIME:
					rowset.updateTimestamp( i+1, new Timestamp(
						new CmnDate( var, "yyyy-MM-dd HH:mm:ss" ).getTime().getTime() ));
					break;
				case Types.BIT:
				case Types.BOOLEAN:
					rowset.updateBoolean( i+1,
						Boolean.valueOf( var ).booleanValue());
					break;
				case Types.TINYINT:
				case Types.BIGINT:
				case Types.INTEGER:
				case Types.SMALLINT:
					rowset.updateInt( i+1,
						Integer.valueOf( var ).intValue());
					break;
				case Types.NUMERIC:
				case Types.DECIMAL:
					rowset.updateBigDecimal( i + 1, new BigDecimal( var ));
					break;
				case Types.DOUBLE:
					rowset.updateDouble( i+1,
						Double.valueOf( var ).doubleValue());
					break;
				case Types.REAL:
				case Types.FLOAT:
					rowset.updateFloat( i+1,
						Float.valueOf( var ).floatValue());
					break;
				default:
					rowset.updateString( i+1, var );
					break;
				}
			}
		}
		return nUpd;
	}

	protected void stopEditing( int row ) {
		for ( int i = 0; i < model.getColumnCount(); i++ ) {
			TableCellEditor editor = sheet.getCellEditor( row, i );
			if ( editor != null ) {
				try {
					editor.stopCellEditing();
				} catch ( NullPointerException ne ) {
				}
			}
		}
	}

	protected void addRow() {
		int row = sheet.getSelectedRow();
		stopEditing( row );
		sheet.getSelectionModel().setSelectionInterval( -1, -1 );
		if ( sheet.getRowCount() == nRow ) {
			model.addRow( new Vector() );
			((DefaultListModel )rowHd.getModel()).addElement( "*" );
		}
		sheet.getSelectionModel().setSelectionInterval( nRow, nRow );
		Rectangle rect = sheet.getCellRect( nRow, 0, true );
		sp.getViewport().scrollRectToVisible( rect );
		// sp.getViewport().requestFocus();
		sheet.requestFocus();
		// sheet.editCellAt( nRow, 0 );
	}

	protected void deleteRow() throws Exception {
		int row = sheet.getSelectedRow();
		if ( row < 0 ) {
			return;
		}
		String title = prop.getString( "viewer.del.title" );
		String msg = prop.getString( "viewer.del.message" );
		int nRet = JOptionPane.showConfirmDialog( this,
					msg, title, JOptionPane.YES_NO_OPTION );
		if ( nRet != JOptionPane.YES_OPTION ) {
			return;
		}
		stopEditing( row );
		if ( row < nRow ) {
			try {
				rowset.absolute( row + 1 );
				rowset.deleteRow();
				rowset.acceptChanges( conWrap );
			} catch ( Exception ex ) {
				rowset.undoDelete();
				throw( ex );
			}
		}
		select( db, con, catalog, schema, table );
	}

	protected void truncate() throws Exception {
		String title;
		String msg;
		int nRet;
		title = prop.getString( "viewer.trunc.title" );
		msg = prop.getString( "viewer.trunc.message1" );
		nRet = JOptionPane.showConfirmDialog( this,
					msg, title, JOptionPane.YES_NO_OPTION );
		if ( nRet != JOptionPane.YES_OPTION ) {
			return;
		}
		msg = prop.getString( "viewer.trunc.message2" );
		nRet = JOptionPane.showConfirmDialog( this,
					msg, title, JOptionPane.YES_NO_OPTION );
		if ( nRet != JOptionPane.YES_OPTION ) {
			return;
		}
		String sql = "TRUNCATE TABLE " + table;
		db.execute( sql );
		select( db, con, catalog, schema, table );
	}

	protected void save() throws Exception {
		CsvParam cprm = param.getCsvParam();
		CsvSaver gen = new CsvSaver( param );
		String file = gen.selectFile( parent, table, selFile );
		if ( file == null ) {
			return;
		}

		PrintWriter out;
		if ( cprm.getEncode() == null ) {
			out = new PrintWriter( new FileWriter( file ));
		} else {
			out = new PrintWriter( new OutputStreamWriter(
				new FileOutputStream( file ), cprm.getEncode() ));
		}

		int sel = sheet.getSelectedRowCount();
		DbTable tbl = new DbTable();
		for ( int row = 0; row < sheet.getRowCount(); row++ ) {
			if ( sel != 0 && !sheet.isRowSelected( row )) {
				continue;
			}
			rowset.absolute( row + 1 );
			db.fetch( rowset, tbl );
			for ( int i = 0; i < tbl.getColumnCount(); i++ ) {
				if ( i > 0 ) {
					out.print( cprm.getColumnSeparator() );
				}
				String dat = tbl.getString( i );
				if ( dat != null ) {
					out.print( dat );
				}
			}
			out.print( cprm.getRowSeparator() );
		}
		out.close();
		selFile = file;
	}

	protected void load() throws Exception {
		CsvParam cprm = param.getCsvParam();
		CsvLoader gen = new CsvLoader( param );
		gen.select( db, con, catalog, schema, table );
		String file = gen.selectFile( parent, table, selFile );
		if ( file == null ) {
			return;
		}
		gen.load( file );
		selFile = file;

		select( db, con, catalog, schema, table );
	}

	protected void showDesigner() throws Exception {
		if ( type == NodeInfo.Type.TABLE ) {
			frmMng.showTableDesigner( catalog, schema, table );
		} else {
			frmMng.showViewDesigner( catalog, schema, table );
		}
	}

	public void closed() {
		try {
			rowset.close();
		} catch ( Exception ex ) {
		}
	}
}
