package	jp.co.sds_corp.jdbrowser.util;

import java.lang.reflect.Method;
import java.sql.Date;
import java.sql.SQLException;
import java.sql.Time;
import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.ParseException;

import com.sun.rowset.CachedRowSetImpl;

public class CachedRowSetWrapper extends CachedRowSetImpl
{
	private static final long serialVersionUID = 1L;

	public CachedRowSetWrapper() throws SQLException {
		super();
	}

	public Timestamp getTimestamp( int i ) throws SQLException {
		Object obj = getObject( i );
		if ( wasNull()) {
			return null;
		}
		// String cls = getMetaData().getColumnClassName(i);
		String cls = obj.getClass().getName();
		if ( cls.equals( "java.sql.Timestamp" )) {
			return (Timestamp)obj;
		} else
		if ( cls.equals( "java.sql.Time" )) {
			long l = ((Time)obj).getTime();
			return new Timestamp(l);
		} else
		if ( cls.equals( "java.sql.Date" )) {
			long l1 = ((Date)obj).getTime();
			return new Timestamp(l1);
		} else
		if ( cls.equals( "java.lang.String" )) {
			try {
				DateFormat dateformat = DateFormat.getTimeInstance();
				return (Timestamp)dateformat.parse(obj.toString());
			} catch ( ParseException parseexception ) {
				throw new SQLException( "timestamp parse error(" + i + ")"
					+ "=" + obj.toString() );
			}
		} else
		if ( cls.equals( "oracle.sql.TIMESTAMP" )) {
			try {
				Method mtd1;
				mtd1 = obj.getClass().getMethod( "getBytes", (Class[] )null );
				byte[] arr = (byte[] )mtd1.invoke( obj, (Object[] )null );
				Method mtd2;
				Class[] prmCls2 = { byte[].class };
				mtd2 = obj.getClass().getMethod( "toTimestamp", prmCls2 );
				Object[] prm2 = { arr };
				Timestamp ret = (Timestamp )mtd2.invoke( obj, prm2 );
				return ret;
			} catch ( Exception ex ) {
				throw new SQLException( "timestamp convert error(" + i + ")"
					+ "=" + obj.getClass().getName() + ";" + obj.toString() );
			}
		} else {
			throw new SQLException( "timestamp class error(" + i + ")"
				+ "=" + obj.getClass().getName() + ";" + obj.toString() );
		}
	}

}
